// RunAsSystem


#include "_commons.h"
#include "error.h"
#include "LocalValue.h"


void printError(const wchar_t* string, int length) {
	DWORD writen;
	::WriteConsole(::GetStdHandle(STD_ERROR_HANDLE), string, length, &writen, NULL);
}

void fatalError(const wchar_t* message, DWORD errorCode) {
	printError(message, ::lstrlen(message));
	wchar_t buffer[256];
	wsprintf(buffer, L": 0x%X\r\n", errorCode);
	printError(buffer, ::lstrlen(buffer));
	auto_LocalHeap<wchar_t> errorMessage;
	DWORD result = ::FormatMessage(
			FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			errorCode, 0,
			reinterpret_cast<LPTSTR>(&errorMessage), 0,
			NULL);
	if (result > 0) {
		printError(errorMessage, result);
	}
	::ExitProcess(errorCode);
}
